/**
 * 
 */
package recursivePossibilitiesStringMVC;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

/**
 * @author deanhougen
 *
 */
public class View extends JFrame implements ActionListener {
	private static final long serialVersionUID = 1;

	private Model model;

	private JLabel instructionLabel = new JLabel("Enter a string:");
	private JTextField entryStringField = new JTextField();
	private JPanel entryPanel = new JPanel(new GridLayout(2, 1));

	private List<String> combinations = null;
	private DefaultListModel<String> combinationListModel = new DefaultListModel<String>();
	private JList<String> combinationList = new JList<String>(combinationListModel);
	private JScrollPane combinationPane = new JScrollPane();
	private JPanel combinationPanel = new JPanel();

	private List<String> possibilities = null;
	private DefaultListModel<String> possibilitiesListModel = new DefaultListModel<String>();
	private JList<String> possibilitiesList = new JList<String>(possibilitiesListModel);
	private JScrollPane possibilitiesPane = new JScrollPane();
	private JPanel possibilitiesPanel = new JPanel();

	/**
	 * 
	 */
	public View() {
		setLayout(new GridLayout(1, 3));
		entryPanel.add(instructionLabel);
		entryPanel.add(entryStringField);
		add(entryPanel);

		combinationPane.setViewportView(combinationList);
		combinationPanel.add(combinationPane);
		add(combinationPanel);

		possibilitiesPane.setViewportView(possibilitiesList);
		possibilitiesPanel.add(possibilitiesPane);
		add(possibilitiesPane);

		pack();
		setLocation(400, 200);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent actionEvent) {
		if (model == null)
			return;

		combinations = model.getCombinations();
		combinationListModel.clear();
		for (String string : combinations) {
			combinationListModel.addElement(string);
		}

		possibilities = model.getPossibilities();
		possibilitiesListModel.clear();
		for (String string : possibilities) {
			possibilitiesListModel.addElement(string);
		}

		repaint();
	}

	/** Set a model */
	public void setModel(Model newModel) {
		model = newModel;

		if (model != null)
			// Register the view as listener for the model
			model.addActionListener(this);

		repaint();
	}

	public String getEntryString() {
		return entryStringField.getText();
	}

	public void addEntryListener(ActionListener entryListener) {
		entryStringField.addActionListener(entryListener);
	}
}
